﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AdministrativeDivision
{
	public partial class QueryDlg : Form
	{
		public QueryDlg()
		{
			InitializeComponent();
			this.btnOK.DialogResult = DialogResult.OK;
			this.btnCancel.DialogResult = DialogResult.Cancel;
		}

		public List<CityNode> Cities { get; set; }
		public CityNode SelectedCity { get; set; }

		private void QueryDlg_Load(object sender, EventArgs e)
		{
			if (this.Cities != null)
			{
				List<CityNode> province = this.Cities.Where(c => c.Code.Substring(2, 4).Equals("0000")).ToList();
				this.comboProvince.DataSource = province;
				this.comboProvince.DisplayMember = "Name";
				this.comboProvince.SelectedIndex = -1;
			}
		}

		private void comboProvince_SelectedIndexChanged(object sender, EventArgs e)
		{
			this.comboPrefectural.Enabled = false;
			this.comboCounty.Enabled = false;
			this.btnOK.Enabled = false;

			CityNode province = this.comboProvince.SelectedItem as CityNode;

			if (province != null)
			{
				List<CityNode> prefectural = this.Cities.Where(c => c.Parent != null).Where(p => p.Parent.Equals(province)).ToList();
				this.comboPrefectural.DataSource = prefectural;
				this.comboPrefectural.DisplayMember = "Name";
				this.comboPrefectural.SelectedIndex = -1;
				this.comboPrefectural.Enabled = true;
			}
		}

		private void comboPrefectural_SelectedIndexChanged(object sender, EventArgs e)
		{
			this.btnOK.Enabled = false;
			this.comboCounty.SelectedIndex = -1;

			CityNode prefectural = this.comboPrefectural.SelectedItem as CityNode;

			if (prefectural != null)
			{
				List<CityNode> county = this.Cities.Where(c => c.Parent != null).Where(p => p.Parent.Equals(prefectural)).ToList();
				this.comboCounty.DataSource = county;
				this.comboCounty.DisplayMember = "Name";
				this.comboCounty.SelectedIndex = -1;
				this.comboCounty.Enabled = true;
			}
		}

		private void comboCounty_SelectedIndexChanged(object sender, EventArgs e)
		{
			if (this.comboCounty.SelectedIndex > 0)
			{
				this.btnOK.Enabled = true;
			}
		}

		private void btnOK_Click(object sender, EventArgs e)
		{
			this.SelectedCity = this.comboCounty.SelectedItem as CityNode;
		}

		private void btnCancel_Click(object sender, EventArgs e)
		{

		}
	}
}
